// This file was generated by qtwaylandscanner
// source file is /usr/src/RPM/BUILD/liri-wayland-0.0.20200726/data/protocols/gtk-shell.xml

#ifndef QT_WAYLAND_SERVER_GTK_SHELL
#define QT_WAYLAND_SERVER_GTK_SHELL

#include "wayland-server-core.h"
#include "wayland-gtk-shell-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  gtk_shell
    {
    public:
        gtk_shell(struct ::wl_client *client, int id, int version);
        gtk_shell(struct ::wl_display *display, int version);
        gtk_shell(struct ::wl_resource *resource);
        gtk_shell();

        virtual ~gtk_shell();

        class Resource
        {
        public:
            Resource() : gtk_shell_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            gtk_shell *gtk_shell_object;
            gtk_shell *object() { return gtk_shell_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum capability {
            capability_global_app_menu = 1,
            capability_global_menu_bar = 2,
            capability_desktop_icons = 3,
        };

        void send_capabilities(uint32_t capabilities);
        void send_capabilities(struct ::wl_resource *resource, uint32_t capabilities);

    protected:
        virtual Resource *gtk_shell_allocate();

        virtual void gtk_shell_bind_resource(Resource *resource);
        virtual void gtk_shell_destroy_resource(Resource *resource);

        virtual void gtk_shell_get_gtk_surface(Resource *resource, uint32_t gtk_surface, struct ::wl_resource *surface);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::gtk_shell_interface m_gtk_shell_interface;

        static void handle_get_gtk_surface(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t gtk_surface,
            struct ::wl_resource *surface);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            gtk_shell *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  gtk_surface
    {
    public:
        gtk_surface(struct ::wl_client *client, int id, int version);
        gtk_surface(struct ::wl_display *display, int version);
        gtk_surface(struct ::wl_resource *resource);
        gtk_surface();

        virtual ~gtk_surface();

        class Resource
        {
        public:
            Resource() : gtk_surface_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            gtk_surface *gtk_surface_object;
            gtk_surface *object() { return gtk_surface_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


    protected:
        virtual Resource *gtk_surface_allocate();

        virtual void gtk_surface_bind_resource(Resource *resource);
        virtual void gtk_surface_destroy_resource(Resource *resource);

        virtual void gtk_surface_set_dbus_properties(Resource *resource, const QString &application_id, const QString &app_menu_path, const QString &menubar_path, const QString &window_object_path, const QString &application_object_path, const QString &unique_bus_name);
        virtual void gtk_surface_set_modal(Resource *resource);
        virtual void gtk_surface_unset_modal(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::gtk_surface_interface m_gtk_surface_interface;

        static void handle_set_dbus_properties(
            ::wl_client *client,
            struct wl_resource *resource,
            const char *application_id,
            const char *app_menu_path,
            const char *menubar_path,
            const char *window_object_path,
            const char *application_object_path,
            const char *unique_bus_name);
        static void handle_set_modal(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_unset_modal(
            ::wl_client *client,
            struct wl_resource *resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            gtk_surface *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
