// This file was generated by qtwaylandscanner
// source file is /usr/src/RPM/BUILD/liri-wayland-0.0.20200726/data/protocols/liri-shell.xml

#ifndef QT_WAYLAND_SERVER_LIRI_SHELL
#define QT_WAYLAND_SERVER_LIRI_SHELL

#include "wayland-server-core.h"
#include "wayland-liri-shell-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  liri_shell
    {
    public:
        liri_shell(struct ::wl_client *client, int id, int version);
        liri_shell(struct ::wl_display *display, int version);
        liri_shell(struct ::wl_resource *resource);
        liri_shell();

        virtual ~liri_shell();

        class Resource
        {
        public:
            Resource() : liri_shell_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            liri_shell *liri_shell_object;
            liri_shell *object() { return liri_shell_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum cursor {
            cursor_none = 0,
            cursor_resize_top = 1,
            cursor_resize_bottom = 2,
            cursor_arrow = 3,
            cursor_resize_left = 4,
            cursor_resize_top_left = 5,
            cursor_resize_bottom_left = 6,
            cursor_move = 7,
            cursor_resize_right = 8,
            cursor_resize_top_right = 9,
            cursor_resize_bottom_right = 10,
            cursor_busy = 11,
        };

        void send_grab_cursor(uint32_t cursor);
        void send_grab_cursor(struct ::wl_resource *resource, uint32_t cursor);
        void send_quit();
        void send_quit(struct ::wl_resource *resource);

    protected:
        virtual Resource *liri_shell_allocate();

        virtual void liri_shell_bind_resource(Resource *resource);
        virtual void liri_shell_destroy_resource(Resource *resource);

        virtual void liri_shell_set_grab_surface(Resource *resource, struct ::wl_resource *surface);
        virtual void liri_shell_ready(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::liri_shell_interface m_liri_shell_interface;

        static void handle_set_grab_surface(
            ::wl_client *client,
            struct wl_resource *resource,
            struct ::wl_resource *surface);
        static void handle_ready(
            ::wl_client *client,
            struct wl_resource *resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            liri_shell *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  liri_osd
    {
    public:
        liri_osd(struct ::wl_client *client, int id, int version);
        liri_osd(struct ::wl_display *display, int version);
        liri_osd(struct ::wl_resource *resource);
        liri_osd();

        virtual ~liri_osd();

        class Resource
        {
        public:
            Resource() : liri_osd_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            liri_osd *liri_osd_object;
            liri_osd *object() { return liri_osd_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_text(const QString &icon_name, const QString &text);
        void send_text(struct ::wl_resource *resource, const QString &icon_name, const QString &text);
        void send_progress(const QString &icon_name, uint32_t value);
        void send_progress(struct ::wl_resource *resource, const QString &icon_name, uint32_t value);

    protected:
        virtual Resource *liri_osd_allocate();

        virtual void liri_osd_bind_resource(Resource *resource);
        virtual void liri_osd_destroy_resource(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        uint32_t m_globalVersion;
        struct DisplayDestroyedListener : ::wl_listener {
            liri_osd *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
