/* Generated by wayland-scanner 1.18.0 */

#ifndef LIRI_DECORATION_SERVER_PROTOCOL_H
#define LIRI_DECORATION_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_liri_decoration The liri_decoration protocol
 * @section page_ifaces_liri_decoration Interfaces
 * - @subpage page_iface_liri_decoration_manager - server-side decoration integration
 * - @subpage page_iface_liri_decoration - server-side decoration interface
 * @section page_copyright_liri_decoration Copyright
 * <pre>
 *
 * Copyright (C) 2018 Pier Luigi Fiorini <pierluigi.fiorini@gmail.com>
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation files
 * (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * </pre>
 */
struct liri_decoration;
struct liri_decoration_manager;
struct wl_surface;

/**
 * @page page_iface_liri_decoration_manager liri_decoration_manager
 * @section page_iface_liri_decoration_manager_desc Description
 *
 * This interface allows a client to alter the look of
 * server-side decorations.
 * @section page_iface_liri_decoration_manager_api API
 * See @ref iface_liri_decoration_manager.
 */
/**
 * @defgroup iface_liri_decoration_manager The liri_decoration_manager interface
 *
 * This interface allows a client to alter the look of
 * server-side decorations.
 */
extern const struct wl_interface liri_decoration_manager_interface;
/**
 * @page page_iface_liri_decoration liri_decoration
 * @section page_iface_liri_decoration_desc Description
 *
 * This interface allows a client to change the server-side decoration
 * background and foreground colors to match the primary color used
 * by the window.
 * @section page_iface_liri_decoration_api API
 * See @ref iface_liri_decoration.
 */
/**
 * @defgroup iface_liri_decoration The liri_decoration interface
 *
 * This interface allows a client to change the server-side decoration
 * background and foreground colors to match the primary color used
 * by the window.
 */
extern const struct wl_interface liri_decoration_interface;

#ifndef LIRI_DECORATION_MANAGER_ERROR_ENUM
#define LIRI_DECORATION_MANAGER_ERROR_ENUM
enum liri_decoration_manager_error {
	/**
	 * the surface already has a liri_decoration object associated
	 */
	LIRI_DECORATION_MANAGER_ERROR_ALREADY_EXISTS = 0,
};
#endif /* LIRI_DECORATION_MANAGER_ERROR_ENUM */

/**
 * @ingroup iface_liri_decoration_manager
 * @struct liri_decoration_manager_interface
 */
struct liri_decoration_manager_interface {
	/**
	 * create a manager object
	 *
	 * Instantiate an interface extention for the given wl_surface to
	 * change the server-side decoration background and foreground
	 * colors.
	 *
	 * If a liri_decoration object has already been associated with
	 * this surface, the compositor will post an error.
	 */
	void (*create)(struct wl_client *client,
		       struct wl_resource *resource,
		       uint32_t id,
		       struct wl_resource *surface);
	/**
	 * release the object
	 *
	 * This destroys the liri_decoration_manager object. It must be
	 * called after all liri_decoration objects are freed. The
	 * compositor is not forced to revert the colors back to the
	 * original ones.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};


/**
 * @ingroup iface_liri_decoration_manager
 */
#define LIRI_DECORATION_MANAGER_CREATE_SINCE_VERSION 1
/**
 * @ingroup iface_liri_decoration_manager
 */
#define LIRI_DECORATION_MANAGER_DESTROY_SINCE_VERSION 1

/**
 * @ingroup iface_liri_decoration
 * @struct liri_decoration_interface
 */
struct liri_decoration_interface {
	/**
	 * set the foreground color
	 *
	 * Change the server-side decoration foreground color in hex
	 * color code (for example #ffffff for white).
	 */
	void (*set_foreground)(struct wl_client *client,
			       struct wl_resource *resource,
			       const char *color);
	/**
	 * set the background color
	 *
	 * Change the server-side decoration background color in hex
	 * color code (for example #ffffff for white).
	 */
	void (*set_background)(struct wl_client *client,
			       struct wl_resource *resource,
			       const char *color);
	/**
	 * release the object
	 *
	 * This destroys the liri_decoration object. The compositor is
	 * not forced to revert the colors back to the original ones.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
};


/**
 * @ingroup iface_liri_decoration
 */
#define LIRI_DECORATION_SET_FOREGROUND_SINCE_VERSION 1
/**
 * @ingroup iface_liri_decoration
 */
#define LIRI_DECORATION_SET_BACKGROUND_SINCE_VERSION 1
/**
 * @ingroup iface_liri_decoration
 */
#define LIRI_DECORATION_DESTROY_SINCE_VERSION 1

#ifdef  __cplusplus
}
#endif

#endif
